;8-damen-2008-doof.scm
(require (lib "breakpoint.ss"))
; ========== Definition des Spielfeldes ===========================
(define
  (felder x y groesse akku)
  (cond
    ((zero? x) akku)
    ((zero? y) (felder (- x 1) groesse groesse akku))
    (else
     (felder x (- y 1) groesse (cons (cons x y) akku)))))
;(define spiel-feld (felder 6 6 6 '()))

; ========== Einbau Praedikate ====================================
; verallgemeinerte Prüffunktion:
(define
  (bedroht? funktion dame damen-liste)
  (member (funktion dame) (map funktion damen-liste)))

(define
  (wird-bedroht? dame damen-liste)
  (or
   (bedroht? car dame damen-liste)
   (bedroht? cdr dame damen-liste)
   (bedroht? (lambda (feld) (- (car feld) (cdr feld))) dame damen-liste)
   (bedroht? (lambda (feld) (+ (car feld) (cdr feld))) dame damen-liste)))

(define
  (liste-ok? damen-liste)
  (cond
    [(null? damen-liste)]
    [(null? (cdr damen-liste))]
    [(wird-bedroht? (car damen-liste) (cdr damen-liste)) #f]
    [else (liste-ok? (cdr damen-liste))]))
  
;;; ===== die eigentliche Suchfunktion =====
(define
  (fuelle felder damen-liste zielgroesse)
  ;(writeln damen-liste)
   (cond
     [(and
       (= (length damen-liste) zielgroesse)
       (liste-ok? damen-liste))
      damen-liste]
     [(null? felder) #f]
     [(= (length damen-liste) zielgroesse) #f]
     [(fuelle (cdr felder) (cons (car felder) damen-liste) zielgroesse)]
     [else
      (fuelle (cdr felder) damen-liste zielgroesse)]))
(fuelle (felder 6 6 6 '()) '() 6)